require '_h2ph_pre.ph';

no warnings 'redefine';

unless(defined(&DMAENGINE_H)) {
    eval 'sub DMAENGINE_H () {1;}' unless defined(&DMAENGINE_H);
    if(defined( &CONFIG_DMA_ENGINE_V3) || defined( &CONFIG_DMA_ENGINE)) {
	require 'linux/device.ph';
	require 'linux/uio.ph';
	unless(defined(&__GENKSYMS__)) {
	    require 'linux/dma-mapping.ph';
	}
	eval("sub DMA_RESOURCE_SUSPEND () { 0; }") unless defined(&DMA_RESOURCE_SUSPEND);
	eval("sub DMA_RESOURCE_RESUME () { 1; }") unless defined(&DMA_RESOURCE_RESUME);
	eval("sub DMA_RESOURCE_ADDED () { 2; }") unless defined(&DMA_RESOURCE_ADDED);
	eval("sub DMA_RESOURCE_REMOVED () { 3; }") unless defined(&DMA_RESOURCE_REMOVED);
	eval 'sub dma_submit_error {
	    my($cookie) = @_;
    	    eval q((($cookie) < 0? 1: 0));
	}' unless defined(&dma_submit_error);
	eval("sub DMA_SUCCESS () { 0; }") unless defined(&DMA_SUCCESS);
	eval("sub DMA_IN_PROGRESS () { 1; }") unless defined(&DMA_IN_PROGRESS);
	eval("sub DMA_ERROR () { 2; }") unless defined(&DMA_ERROR);
	unless(defined(&__GENKSYMS__)) {
	}
	if(defined(&CONFIG_DMA_ENGINE_V3)) {
	} else {
	    eval 'sub dmaengine_get {
	        my($void) = @_;
    		eval q({ });
	    }' unless defined(&dmaengine_get);
	    eval 'sub dmaengine_put {
	        my($void) = @_;
    		eval q({ });
	    }' unless defined(&dmaengine_put);
	}
	unless(defined(&__GENKSYMS__)) {
	}
	eval 'sub dma_submit_error {
	    my($cookie) = @_;
    	    eval q((($cookie) < 0? 1: 0));
	}' unless defined(&dma_submit_error);
	eval("sub DMA_MEMCPY () { 0; }") unless defined(&DMA_MEMCPY);
	eval("sub DMA_XOR () { 1; }") unless defined(&DMA_XOR);
	eval("sub DMA_PQ_XOR () { 2; }") unless defined(&DMA_PQ_XOR);
	eval("sub DMA_DUAL_XOR () { 3; }") unless defined(&DMA_DUAL_XOR);
	eval("sub DMA_PQ_UPDATE () { 4; }") unless defined(&DMA_PQ_UPDATE);
	eval("sub DMA_ZERO_SUM () { 5; }") unless defined(&DMA_ZERO_SUM);
	eval("sub DMA_PQ_ZERO_SUM () { 6; }") unless defined(&DMA_PQ_ZERO_SUM);
	eval("sub DMA_MEMSET () { 7; }") unless defined(&DMA_MEMSET);
	eval("sub DMA_MEMCPY_CRC32C () { 8; }") unless defined(&DMA_MEMCPY_CRC32C);
	eval("sub DMA_INTERRUPT () { 9; }") unless defined(&DMA_INTERRUPT);
	eval("sub DMA_PRIVATE () { 10; }") unless defined(&DMA_PRIVATE);
	eval("sub DMA_SLAVE () { 11; }") unless defined(&DMA_SLAVE);
	eval 'sub DMA_TX_TYPE_END () {( &DMA_SLAVE + 1);}' unless defined(&DMA_TX_TYPE_END);
	eval("sub DMA_PREP_INTERRUPT () { (1<<0); }") unless defined(&DMA_PREP_INTERRUPT);
	eval("sub DMA_CTRL_ACK () { (1<<1); }") unless defined(&DMA_CTRL_ACK);
	eval("sub DMA_COMPL_SKIP_SRC_UNMAP () { (1<<2); }") unless defined(&DMA_COMPL_SKIP_SRC_UNMAP);
	eval("sub DMA_COMPL_SKIP_DEST_UNMAP () { (1<<3); }") unless defined(&DMA_COMPL_SKIP_DEST_UNMAP);
	eval("sub DMA_COMPL_SRC_UNMAP_SINGLE () { (1<<4); }") unless defined(&DMA_COMPL_SRC_UNMAP_SINGLE);
	eval("sub DMA_COMPL_DEST_UNMAP_SINGLE () { (1<<5); }") unless defined(&DMA_COMPL_DEST_UNMAP_SINGLE);
	if(defined(&CONFIG_DMA_ENGINE_V3)) {
	} else {
	    eval 'sub dma_wait_for_async_tx {
	        my($tx) = @_;
    		eval q({  &DMA_SUCCESS; });
	    }' unless defined(&dma_wait_for_async_tx);
	    eval 'sub dma_issue_pending_all {
	        my($void) = @_;
    		eval q({  &do { }  &while (0); });
	    }' unless defined(&dma_issue_pending_all);
	}
	eval 'sub async_tx_ack {
	    my($tx) = @_;
    	    eval q({  ($tx->{flags}) |=  &DMA_CTRL_ACK; });
	}' unless defined(&async_tx_ack);
	eval 'sub async_tx_clear_ack {
	    my($tx) = @_;
    	    eval q({  ($tx->{flags}) &= ~ &DMA_CTRL_ACK; });
	}' unless defined(&async_tx_clear_ack);
	eval 'sub async_tx_test_ack {
	    my($tx) = @_;
    	    eval q({ ( ($tx->{flags}) &  &DMA_CTRL_ACK) ==  &DMA_CTRL_ACK; });
	}' unless defined(&async_tx_test_ack);
	eval 'sub first_dma_cap {
	    my($mask) = @_;
    	    eval q( &__first_dma_cap(($mask)));
	}' unless defined(&first_dma_cap);
	eval 'sub __first_dma_cap {
	    my($srcp) = @_;
    	    eval q({  &min_t(\'int\',  &DMA_TX_TYPE_END,  &find_first_bit( ($srcp->{bits}),  &DMA_TX_TYPE_END)); });
	}' unless defined(&__first_dma_cap);
	eval 'sub next_dma_cap {
	    my($n, $mask) = @_;
    	    eval q( &__next_dma_cap(($n), ($mask)));
	}' unless defined(&next_dma_cap);
	eval 'sub __next_dma_cap {
	    my($n,$srcp) = @_;
    	    eval q({  &min_t(\'int\',  &DMA_TX_TYPE_END,  &find_next_bit( ($srcp->{bits}),  &DMA_TX_TYPE_END, $n+1)); });
	}' unless defined(&__next_dma_cap);
	eval 'sub dma_cap_set {
	    my($tx, $mask) = @_;
    	    eval q( &__dma_cap_set(($tx), ($mask)));
	}' unless defined(&dma_cap_set);
	eval 'sub __dma_cap_set {
	    my($tx_type,$dstp) = @_;
    	    eval q({  &set_bit($tx_type,  ($dstp->{bits})); });
	}' unless defined(&__dma_cap_set);
	eval 'sub dma_cap_clear {
	    my($tx, $mask) = @_;
    	    eval q( &__dma_cap_clear(($tx), ($mask)));
	}' unless defined(&dma_cap_clear);
	eval 'sub __dma_cap_clear {
	    my($tx_type,$dstp) = @_;
    	    eval q({  &clear_bit($tx_type,  ($dstp->{bits})); });
	}' unless defined(&__dma_cap_clear);
	eval 'sub dma_cap_zero {
	    my($mask) = @_;
    	    eval q( &__dma_cap_zero(($mask)));
	}' unless defined(&dma_cap_zero);
	eval 'sub __dma_cap_zero {
	    my($dstp) = @_;
    	    eval q({  &bitmap_zero( ($dstp->{bits}),  &DMA_TX_TYPE_END); });
	}' unless defined(&__dma_cap_zero);
	eval 'sub dma_has_cap {
	    my($tx, $mask) = @_;
    	    eval q( &__dma_has_cap(($tx), ($mask)));
	}' unless defined(&dma_has_cap);
	eval 'sub __dma_has_cap {
	    my($tx_type,$srcp) = @_;
    	    eval q({  &test_bit($tx_type,  ($srcp->{bits})); });
	}' unless defined(&__dma_has_cap);
	eval 'sub for_each_dma_cap_mask {
	    my($cap, $mask) = @_;
    	    eval q( &for (($cap) =  &first_dma_cap($mask); ($cap) <  &DMA_TX_TYPE_END; ($cap) =  &next_dma_cap(($cap), ($mask))));
	}' unless defined(&for_each_dma_cap_mask);
	eval 'sub dma_async_memcpy_issue_pending_v3 {
	    my($chan) = @_;
    	    eval q( &dma_async_issue_pending($chan));
	}' unless defined(&dma_async_memcpy_issue_pending_v3);
	eval 'sub dma_async_memcpy_complete_v3 {
	    my($chan, $cookie, $last, $used) = @_;
    	    eval q( &dma_async_is_tx_complete($chan, $cookie, $last, $used));
	}' unless defined(&dma_async_memcpy_complete_v3);
	eval 'sub dma_request_channel {
	    my($mask, $x, $y) = @_;
    	    eval q( &__dma_request_channel(($mask), $x, $y));
	}' unless defined(&dma_request_channel);
    }
    if(defined(&CONFIG_NET_DMA)) {
	eval 'sub net_dmaengine_get () {
	    eval q( &dmaengine_get());
	}' unless defined(&net_dmaengine_get);
	eval 'sub net_dmaengine_put () {
	    eval q( &dmaengine_put());
	}' unless defined(&net_dmaengine_put);
    } else {
	eval 'sub net_dmaengine_get {
	    my($void) = @_;
    	    eval q({ });
	}' unless defined(&net_dmaengine_get);
	eval 'sub net_dmaengine_put {
	    my($void) = @_;
    	    eval q({ });
	}' unless defined(&net_dmaengine_put);
    }
}
1;
